// CLandScape.cpp
// by Comanche

#include "CLandScape.h"
#include "CMain.h"
#include "CGraphics.h"
#include "CLog.h"
#include "CTexture.h"
#include "CMenu.h"
#include "CCheckBox.h"

extern CLandScape Land;
extern CMain GameMain;
extern CGraphics Graphics;
extern CLog Log;
extern CTexture *Masks[3];
extern CTexture *Textures[1024];
extern CCheckBox *CheckBoxes[20];
extern CMenu Menu;

//////////////////////////////////////////////////////////////////////////////////

CLandScape::CLandScape()
{
	ScreenPosX=0; ScreenPosY=0;
}

//////////////////////////////////////////////////////////////////////////////////

BOOL CLandScape::InitScreen()
{	
	FillScreen(101,0,559,479);
	return(TRUE);
}

//////////////////////////////////////////////////////////////////////////////////

void CLandScape::PutVoxel(int x,int y,int x2,int y2)
{
	int red,green,blue;
	float multi;
	
	////////////////////////////////////////////////////////////
	// Algorithmus										      //
	////////////////////////////////////////////////////////////
	//														  //
	//	for(int i=64;i>=0;i--)                                //
	//	{													  //
	//		pointer=(BYTE*)&Landscape[x][y+i];				  //
	//		if((y+i)>1999) continue;						  //
	//		height=*(pointer+3);							  //
	//		if(height>=i)									  //
	//		{												  //
	//			float shadow=GetShadow(x,y+i,i);			  //			
	//			blue=(*pointer)*shadow;						  //
	//			if(blue>255) blue=255;						  //
	//			green=(*(++pointer))*shadow;				  //
	//			if(green>255) green=255;					  //
	//			red=(*(++pointer))*shadow;					  //
	//			if(red>255) red=255;						  //
	//			Graphics.PutPixel(x2,y2,red,green,blue);	  //
	//			break;										  //
	//		}												  //
	//	}													  //
	//														  //
	////////////////////////////////////////////////////////////
	
	__asm
	{
		mov eax,x					// Adresse berechnen
		imul eax,8000				// 2000*4 Bytes pro Zeile
		mov ebx,y
		lea eax,[eax+ebx*4+Land.Landscape+3]
		// 3 Bytes dazu weil Hhe Byte 4 im DWORD ist

		mov ecx,64					// Counter auf 64 (max-Hhe = 64)

jmp1:	mov dl,BYTE PTR [eax+ecx*4]	// Hhe laden
		cmp dl,cl					// und mit Counter vergleichen
		jae jmp2					// wenn gleich oder hher jmp2									
		loop jmp1					// loop (ecx-1)

jmp2:	lea eax,[eax+ecx*4-3]		// auf Farben gehen (minus 3 Bytes)
		xor ebx,ebx					// Farben 32-Bit breit speichern wegen FILD
		mov bl,BYTE PTR [eax]		// Blau
		mov blue,ebx         
		inc eax						// Grn
		mov bl,BYTE PTR [eax]		
		mov green,ebx
		inc eax						// Rot
		mov bl,BYTE PTR [eax]
		mov red,ebx					// auf Hhe gehen

		cmp x,1998
		ja equal
				
		add eax,7997				// +1, -1 (+8000-4+1)
		mov bl,BYTE PTR [eax]       // dl old, bl new
		cmp cl,bl
		ja above					// hher
		jb below					// niedriger
		
equal:	jmp jmp4					// gleich, nicht zu tun !

above:  inc bl					
		cmp cl,bl					// testen ob nur 1 hher
		jne above1
		mov multi,03F4CCCCDh		// ja x0.8
		jmp jmp3
above1: inc bl						// testen ob nur 2 hher
		cmp cl,bl			
		jne above2
		mov multi,03F19999Ah		// ja x0.6
		jmp jmp3
above2: inc bl						// testen ob nur 3 hher
		cmp cl,bl
		jne above3
		mov multi,03ECCCCCDh		// ja x0.4
		jmp jmp3
above3:	mov multi,03E4CCCCDh		// x0.2
		jmp jmp3

below:  dec bl						// testen ob nur 1 niedriger
		cmp cl,bl
		jne below1
		mov multi,03F99999Ah		// ja x1.2
		jmp jmp3
below1: dec bl						// testen ob nur 2 niedriger
		cmp cl,bl		
		jne below2
		mov multi,03FB33333h		// ja x1.4
		jmp jmp3
below2: dec bl						// testen ob nur 3 niedriger
		cmp cl,bl
		jne below3
		mov multi,03FCCCCCDh		// ja x1.6
		jmp jmp3
below3:	mov multi,03FE66666h		// x1.8

jmp3:	fld multi
		fild red
		fmul st,st(1)
		fistp red
		fild green
		fmul st,st(1)
		fistp green
		fild blue
		fmul st,st(1)
		fistp blue
		ffree st
		
		mov eax,red
		cmp eax,0FFh
		jbe okr
		mov red,0FFh
okr:	mov eax,green
		cmp eax,0FFh
		jbe okg
		mov green,0FFh
okg:	mov eax,blue
		cmp eax,0FFh
		jbe jmp4
		mov blue,0FFh
		
jmp4:	mov eax,y2					// Grafikspeicher Koordinaten rechnen
		mov ebx,x2
		mul WordsPerLine
		lea eax,[eax+ebx*4]			// 32-Bit Farbtiefe
		add eax,video_buffer

		mov ebx,blue				// Und Pixel speichern
		mov BYTE PTR [eax],bl
		inc eax
		mov ebx,green
		mov BYTE PTR [eax],bl
		inc eax
		mov ebx,red
		mov BYTE PTR [eax],bl

end:	inc Land.vps
	}
}

//////////////////////////////////////////////////////////////////////////////////

void CLandScape::FillScreen(int x,int y,int x2,int y2)
{
/*	__asm
	{
		mov edx,x2
		sub edx,x
		
loop1:	mov ecx,y2
		sub ecx,y
loop2:	push edx
		push ecx
		add edx,Land.ScreenPosX
		sub edx,100
		push edx
		add ecx,Land.ScreenPosY
		push ecx
		call Land.PutVoxel
		loop loop2
		dec edx
		jnz loop1
	}*/
	
	for(int i=x;i<=x2;i++)
	{
		for(int i2=y;i2<=y2;i2++)
		{
			int posx=ScreenPosX+i-100;
			int posy=ScreenPosY+i2;
			PutVoxel(posx,posy,i,i2);
		}
	}
}

//////////////////////////////////////////////////////////////////////////////////

inline void CLandScape::PutBrightVoxel(int x,int y,int x2,int y2)
{
	int red,green,blue;
	float multi;

	__asm
	{
		mov eax,x					// Adresse berechnen
		imul eax,8000				// 2000*4 Bytes pro Zeile
		mov ebx,y
		lea eax,[eax+ebx*4+Land.Landscape+3]
		// 3 Bytes dazu weil Hhe Byte 4 im DWORD ist

		mov ecx,64					// Counter auf 64 (max-Hhe = 64)

jmp1:	mov dl,BYTE PTR [eax+ecx*4]	// Hhe laden
		cmp dl,cl					// und mit Counter vergleichen
		jae jmp2					// wenn gleich oder hher jmp2									
		loop jmp1					// loop (ecx-1)

jmp2:	lea eax,[eax+ecx*4-3]		// auf Farben gehen (minus 3 Bytes)
		xor ebx,ebx					// Farben 32-Bit breit speichern wegen FILD
		mov bl,BYTE PTR [eax]		// Blau
		mov blue,ebx         
		mov bl,BYTE PTR [eax+1]		// Grn
		mov green,ebx		
		mov bl,BYTE PTR [eax+2]		// Rot
		mov red,ebx					// auf Hhe gehen
	
		mov bl,BYTE PTR [eax+7999]  // dl old, bl new; +1, -1 (+8000-4+1)
		cmp cl,bl
		ja above					// hher
		jb below					// niedriger
		
equal:	jmp jmp4					// gleich, nicht zu tun !

above:  inc bl					
		cmp cl,bl					// testen ob nur 1 hher
		jne above1
		mov multi,03F4CCCCDh		// ja x0.8
		jmp jmp3
above1: inc bl						// testen ob nur 2 hher
		cmp cl,bl			
		jne above2
		mov multi,03F19999Ah		// ja x0.6
		jmp jmp3
above2: inc bl						// testen ob nur 3 hher
		cmp cl,bl
		jne above3
		mov multi,03ECCCCCDh		// ja x0.4
		jmp jmp3
above3:	mov multi,03E4CCCCDh		// x0.2
		jmp jmp3

below:  dec bl						// testen ob nur 1 niedriger
		cmp cl,bl
		jne below1
		mov multi,03F99999Ah		// ja x1.2
		jmp jmp3
below1: dec bl						// testen ob nur 2 niedriger
		cmp cl,bl		
		jne below2
		mov multi,03FB33333h		// ja x1.4
		jmp jmp3
below2: dec bl						// testen ob nur 3 niedriger
		cmp cl,bl
		jne below3
		mov multi,03FCCCCCDh		// ja x1.6
		jmp jmp3
below3:	mov multi,03FE66666h		// x1.8

jmp3:	fld multi
		fild red
		fmul st,st(1)
		fistp red
		fild green
		fmul st,st(1)
		fistp green
		fild blue
		fmul st,st(1)
		fistp blue
		ffree st

jmp4:	mov eax,red
		cmp eax,0D7h					// rot +20 (<=255!)
		jbe rjmp
		mov eax,0FFh
		jmp rjmp2
rjmp:	add eax,028h
rjmp2:	mov red,eax
						
		mov ebx,green
		cmp ebx,0D7h					// grn +20 (<=255!)
		jbe gjmp
		mov ebx,0FFh
		jmp gjmp2
gjmp:	add ebx,028h
gjmp2:	mov green,ebx

		mov ecx,blue
		cmp ecx,0D7h					// blau +20 (<=255!)
		jbe bjmp
		mov ecx,0FFh
		jmp bjmp2
bjmp:	add ecx,028h
bjmp2:	mov blue,ecx

		mov eax,y2						// Grafikspeicher Koordinaten rechnen
		mov ebx,x2
		mul WordsPerLine
		lea eax,[eax+ebx*4]				// 32-Bit Farbtiefe
		add eax,video_buffer

		mov ebx,blue					// Und Pixel speichern
		mov BYTE PTR [eax],bl
		inc eax
		mov ebx,green
		mov BYTE PTR [eax],bl
		inc eax
		mov ebx,red
		mov BYTE PTR [eax],bl

end:	inc Land.vps
	}
}

//////////////////////////////////////////////////////////////////////////////////
//	RIP																			//
//////////////////////////////////////////////////////////////////////////////////
//	inline float CLandScape::GetShadow(int x,int y,int height)					//
//	{																			//
//		if((x+1)>1999) return(1.0);												//
//		if((y-1)<0) return(1.0);												//
//																				//
//		BYTE *pointer;															//
//																				//
//		pointer=(BYTE*)&Landscape[++x][--y];									//
//		pointer+=3;																//
//																				//
//		if(*pointer+1==height) return(0.8);										//
//		if(*pointer+2==height) return(0.6);										//
//		if(*pointer+3==height) return(0.4);										//
//		if(*pointer<height) return(0.2);										//
//		if(*pointer-1==height) return(1.2);										//
//		if(*pointer-2==height) return(1.4);										//
//		if(*pointer-3==height) return(1.6);										//
//		if(*pointer>height) return(1.8);										//
//		return(1.0);															//			
//	}																			//
//////////////////////////////////////////////////////////////////////////////////

void CLandScape::DrawBrush()
{
	RGBTRIPLE color;
	BYTE height;
	BYTE *pointer;

	if(GameMain.Status2==7)
		return;

	if(GameMain.MouseX>100 && GameMain.MouseX<560)
	{
		if(GameMain.Status==0)
		{
			Graphics.LockBackBuffer();
			for(int i=0;i<32;i++)
				for(int i2=0;i2<32;i2++)
			{
				int posx=ScreenPosX+GameMain.MouseX-100+i-16;
				int posy=ScreenPosY+GameMain.MouseY+i2-16;
				int posx2=GameMain.MouseX+i-16;
				int posy2=GameMain.MouseY+i2-16;
				
				if(posx2<101 || posx2>559) continue;				
								
				pointer=(BYTE*)&Landscape[posx][posy];
				pointer+=3;
				height=*pointer;
				
				if(posy2-height<0) continue;
				if(posy2-height>639) continue;

				color=Masks[2]->GetPixel(i,i2);			
				if(color.rgbtRed)
					PutBrightVoxel(posx,posy-height,posx2,posy2-height);				
			}
			Graphics.UnLockBackBuffer();
		}

		if(GameMain.Status==1)
		{
			Graphics.LockBackBuffer();
			for(int i=0;i<64;i++)
				for(int i2=0;i2<64;i2++)
			{
				int posx=ScreenPosX+GameMain.MouseX-100+i-32;
				int posy=ScreenPosY+GameMain.MouseY+i2-32;
				int posx2=GameMain.MouseX+i-32;
				int posy2=GameMain.MouseY+i2-32;
				
				if(posx2<101 || posx2>559) continue;
				
				pointer=(BYTE*)&Landscape[posx][posy];
				pointer+=3;
				height=*pointer;
				
				if(posy2-height<0) continue;
				if(posy2-height>639) continue;
			
				color=Masks[1]->GetPixel(i,i2);
				if(color.rgbtRed)
					PutBrightVoxel(posx,posy-height,posx2,posy2-height);				
			}
			Graphics.UnLockBackBuffer();
		}

		if(GameMain.Status==2)
		{
			Graphics.LockBackBuffer();
			for(int i=0;i<96;i++)
				for(int i2=0;i2<96;i2++)
			{
				int posx=ScreenPosX+GameMain.MouseX-100+i-48;
				int posy=ScreenPosY+GameMain.MouseY+i2-48;
				int posx2=GameMain.MouseX+i-48;
				int posy2=GameMain.MouseY+i2-48;
				
				if(posx2<101 || posx2>559) continue;
				
				pointer=(BYTE*)&Landscape[posx][posy];
				pointer+=3;
				height=*pointer;
				
				if(posy2-height<0) continue;
				if(posy2-height>639) continue;
			
				color=Masks[0]->GetPixel(i,i2);
				if(color.rgbtRed)
					PutBrightVoxel(posx,posy-height,posx2,posy2-height);				
			}
			Graphics.UnLockBackBuffer();
		}
	}
}

//////////////////////////////////////////////////////////////////////////////////

void CLandScape::UseBrush()
{
	if(GameMain.Status2==0)
		Higher();
	if(GameMain.Status2==1)
		Lower();
	if(GameMain.Status2==2)
		Brush();
	if(GameMain.Status2==3)
		Smoth();
	if(GameMain.Status2==4)
		Level();
	if(GameMain.Status2==5)
		Spray();
	if(GameMain.Status2==6)
		Transparent();
}

//////////////////////////////////////////////////////////////////////////////////

inline void CLandScape::Higher()
{
	RGBTRIPLE color;
	BYTE *pointer;
	BYTE oldheight;

	if(GameMain.Status==0)
	{
		for(int i=0;i<32;i++)
			for(int i2=0;i2<32;i2++)
		{			
			int posx=ScreenPosX+GameMain.MouseX-100+i-16;
			int posy=ScreenPosY+GameMain.MouseY+i2-16;
			int posx2=GameMain.MouseX+i-16;
			int posy2=GameMain.MouseY+i2-16;
			
			if(posx2<101 || posx2>559) continue;
			if(posy2<0 || posy2>479) continue;
			
			color=Masks[2]->GetPixel(i,i2);
			if(color.rgbtRed)
			{
				pointer=(BYTE*)&Landscape[posx][posy];	
				pointer+=3;
				*pointer+=1;
				if(*pointer>64) *pointer=64;
			}		
		}

		Graphics.Lock();
		for(i=0;i<32;i++)
			for(int i2=0;i2<32;i2++)
		{			
			int posx=ScreenPosX+GameMain.MouseX-100+i-16;
			int posy=ScreenPosY+GameMain.MouseY+i2-16;
			int posx2=GameMain.MouseX+i-16;
			int posy2=GameMain.MouseY+i2-16;
			
			if(posx2<101 || posx2>559) continue;
			if(posy2<0 || posy2>479) continue;
			
			color=Masks[2]->GetPixel(i,i2);
			if(color.rgbtRed)
			{
				pointer=(BYTE*)&Landscape[posx][posy];	
				pointer+=3;
				PutVoxel(posx,posy-*pointer,posx2,posy2-*pointer);				
			}		
		}
		Graphics.UnLock();
	}

	///////////////////////////////////////////////////////////

	if(GameMain.Status==1)
	{
		for(int i=0;i<64;i++)
			for(int i2=0;i2<64;i2++)
		{
			int posx=ScreenPosX+GameMain.MouseX-100+i-32;
			int posy=ScreenPosY+GameMain.MouseY+i2-32;
			int posx2=GameMain.MouseX+i-32;
			int posy2=GameMain.MouseY+i2-32;
				
			if(posx2<101 || posx2>559) continue;
			if(posy2<0 || posy2>479) continue;
			
			color=Masks[1]->GetPixel(i,i2);
			if(color.rgbtRed)
			{
				pointer=(BYTE*)&Landscape[posx][posy];
				pointer+=3;
				*pointer+=1;
				if(*pointer>64) *pointer=64;
			}
		}

		Graphics.Lock();
		for(i=0;i<64;i++)
			for(int i2=0;i2<64;i2++)
		{			
			int posx=ScreenPosX+GameMain.MouseX-100+i-32;
			int posy=ScreenPosY+GameMain.MouseY+i2-32;
			int posx2=GameMain.MouseX+i-32;
			int posy2=GameMain.MouseY+i2-32;
			
			if(posx2<101 || posx2>559) continue;
			if(posy2<0 || posy2>479) continue;
			
			color=Masks[1]->GetPixel(i,i2);
			if(color.rgbtRed)
			{
				pointer=(BYTE*)&Landscape[posx][posy];	
				pointer+=3;
				PutVoxel(posx,posy-*pointer,posx2,posy2-*pointer);				
			}		
		}
		Graphics.UnLock();
	}

	///////////////////////////////////////////////////////////

	if(GameMain.Status==2)
	{
		for(int i=0;i<96;i++)
			for(int i2=0;i2<96;i2++)
		{
			int posx=ScreenPosX+GameMain.MouseX-100+i-48;
			int posy=ScreenPosY+GameMain.MouseY+i2-48;
			int posx2=GameMain.MouseX+i-48;
			int posy2=GameMain.MouseY+i2-48;
			
			if(posx2<101 || posx2>559) continue;
			if(posy2<0 || posy2>479) continue;
	
			color=Masks[0]->GetPixel(i,i2);
			if(color.rgbtRed)
			{
				pointer=(BYTE*)&Landscape[posx][posy];
				pointer+=3;
				*pointer+=1;
				if(*pointer>64) *pointer=64;
				PutVoxel(posx,posy-*pointer,posx2,posy2-*pointer);				
			}
		}

		Graphics.Lock();
		for(i=0;i<96;i++)
			for(int i2=0;i2<96;i2++)
		{			
			int posx=ScreenPosX+GameMain.MouseX-100+i-48;
			int posy=ScreenPosY+GameMain.MouseY+i2-48;
			int posx2=GameMain.MouseX+i-48;
			int posy2=GameMain.MouseY+i2-48;
			
			if(posx2<101 || posx2>559) continue;
			if(posy2<0 || posy2>479) continue;
			
			color=Masks[0]->GetPixel(i,i2);
			if(color.rgbtRed)
			{
				pointer=(BYTE*)&Landscape[posx][posy];	
				pointer+=3;
				PutVoxel(posx,posy-*pointer,posx2,posy2-*pointer);				
			}		
		}
		Graphics.UnLock();
	}
}

//////////////////////////////////////////////////////////////////////////////////

inline void	CLandScape::Lower()
{
	RGBTRIPLE color;
	BYTE *pointer;

	if(GameMain.Status==0)
	{
		Graphics.Lock();
		for(int i=0;i<32;i++)
			for(int i2=0;i2<32;i2++)
		{			
			int posx=ScreenPosX+GameMain.MouseX-100+i-16;
			int posy=ScreenPosY+GameMain.MouseY+i2-16;
			int posx2=GameMain.MouseX+i-16;
			int posy2=GameMain.MouseY+i2-16;
			
			if(posx2<101 || posx2>559) continue;
			if(posy2<0 || posy2>479) continue;
			
			color=Masks[2]->GetPixel(i,i2);
			if(color.rgbtRed)
			{
				pointer=(BYTE*)&Landscape[posx][posy];	
				pointer+=3;
				if(*pointer!=0)
					*pointer-=1;
				PutVoxel(posx,posy,posx2,posy2);
			}
		}
		Graphics.UnLock();
	}

	///////////////////////////////////////////////////////////

	if(GameMain.Status==1)
	{
		Graphics.Lock();
		for(int i=0;i<64;i++)
			for(int i2=0;i2<64;i2++)
		{
			int posx=ScreenPosX+GameMain.MouseX-100+i-32;
			int posy=ScreenPosY+GameMain.MouseY+i2-32;
			int posx2=GameMain.MouseX+i-32;
			int posy2=GameMain.MouseY+i2-32;
				
			if(posx2<101 || posx2>559) continue;
			if(posy2<0 || posy2>479) continue;
			
			color=Masks[1]->GetPixel(i,i2);
			if(color.rgbtRed)
			{
				pointer=(BYTE*)&Landscape[posx][posy];
				pointer+=3;
				if(*pointer!=0)
					*pointer-=1;
				PutVoxel(posx,posy,posx2,posy2);
			}
		Graphics.UnLock();
		}
	}

	///////////////////////////////////////////////////////////

	if(GameMain.Status==2)
	{
		Graphics.Lock();
		for(int i=0;i<96;i++)
			for(int i2=0;i2<96;i2++)
		{
			int posx=ScreenPosX+GameMain.MouseX-100+i-48;
			int posy=ScreenPosY+GameMain.MouseY+i2-48;
			int posx2=GameMain.MouseX+i-48;
			int posy2=GameMain.MouseY+i2-48;
			
			if(posx2<101 || posx2>559) continue;
			if(posy2<0 || posy2>479) continue;
	
			color=Masks[0]->GetPixel(i,i2);
			if(color.rgbtRed)
			{
				pointer=(BYTE*)&Landscape[posx][posy];
				pointer+=3;
				if(*pointer!=0)
					*pointer-=1;
				PutVoxel(posx,posy,posx2,posy2);
			}
		}
		Graphics.UnLock();
	}
}

//////////////////////////////////////////////////////////////////////////////////

inline void CLandScape::Brush()
{
	if(Menu.Selection==-1) return;

	DWORD buffer2;
	int TexPos=Menu.ScrolPos+Menu.Selection;
	int x,y,x2,y2;
	int a,b;
	RGBTRIPLE color;
	float red,green,blue;
	float ored,ogreen,oblue;
	BYTE *pointer;
	BYTE height;

	if(GameMain.Status==0)
	{
		Graphics.Lock();
		for(int i=0;i<32;i++)
			for(int i2=0;i2<32;i2++)
		{			
			int posx=ScreenPosX+GameMain.MouseX-100+i-16;
			int posy=ScreenPosY+GameMain.MouseY+i2-16;
			int posx2=GameMain.MouseX+i-16;
			int posy2=GameMain.MouseY+i2-16;
			
			if(posx2<101 || posx2>559) continue;
			if(posy2<0 || posy2>479) continue;
			
			color=Masks[2]->GetPixel(i,i2);
			if(color.rgbtRed)
			{
				a=255-color.rgbtRed;

				x=posx/Textures[TexPos]->width;
				y=posy/Textures[TexPos]->height;
				x2=posx-(x*Textures[TexPos]->width);
				y2=posy-(y*Textures[TexPos]->height);
				
				pointer=(BYTE*)&Landscape[posx][posy];
				oblue=*pointer;ogreen=*(++pointer);ored=*(++pointer);

				color=Textures[TexPos]->GetPixel(x2,y2);
				red=color.rgbtRed;green=color.rgbtGreen;blue=color.rgbtBlue;

				red=GetAlpha(red,ored,a);
				blue=GetAlpha(blue,oblue,a);
				green=GetAlpha(green,ogreen,a);
				
				pointer=(BYTE*)&Landscape[posx][posy];
				*pointer=blue;
				*(++pointer)=green;
				*(++pointer)=red;

				height=*(++pointer);
				for(int i3=0;i3<=height;i3++)
					PutVoxel(posx,posy-i3,posx2,posy2-i3);
			}
		}
		Graphics.UnLock();

	}

	///////////////////////////////////////////////////////////

	if(GameMain.Status==1)
	{
		Graphics.Lock();
		for(int i=0;i<64;i++)
			for(int i2=0;i2<64;i2++)
		{
			int posx=ScreenPosX+GameMain.MouseX-100+i-32;
			int posy=ScreenPosY+GameMain.MouseY+i2-32;
			int posx2=GameMain.MouseX+i-32;
			int posy2=GameMain.MouseY+i2-32;
				
			if(posx2<101 || posx2>559) continue;
			if(posy2<0 || posy2>479) continue;
			
			color=Masks[1]->GetPixel(i,i2);
			if(color.rgbtRed)
			{
				a=255-color.rgbtRed;

				x=posx/Textures[TexPos]->width;
				y=posy/Textures[TexPos]->height;
				x2=posx-(x*Textures[TexPos]->width);
				y2=posy-(y*Textures[TexPos]->height);
				
				pointer=(BYTE*)&Landscape[posx][posy];
				oblue=*pointer;ogreen=*(++pointer);ored=*(++pointer);

				color=Textures[TexPos]->GetPixel(x2,y2);
				red=color.rgbtRed;green=color.rgbtGreen;blue=color.rgbtBlue;

				red=GetAlpha(red,ored,a);
				blue=GetAlpha(blue,oblue,a);
				green=GetAlpha(green,ogreen,a);
				
				pointer=(BYTE*)&Landscape[posx][posy];
				*pointer=blue;
				*(++pointer)=green;
				*(++pointer)=red;

				height=*(++pointer);
				for(int i3=0;i3<=height;i3++)
					PutVoxel(posx,posy-i3,posx2,posy2-i3);
			}
		}
		Graphics.UnLock();
	}

	///////////////////////////////////////////////////////////

	if(GameMain.Status==2)
	{
		Graphics.Lock();
		for(int i=0;i<96;i++)
			for(int i2=0;i2<96;i2++)
		{
			int posx=ScreenPosX+GameMain.MouseX-100+i-48;
			int posy=ScreenPosY+GameMain.MouseY+i2-48;
			int posx2=GameMain.MouseX+i-48;
			int posy2=GameMain.MouseY+i2-48;
			
			if(posx2<101 || posx2>559) continue;
			if(posy2<0 || posy2>479) continue;
	
			color=Masks[0]->GetPixel(i,i2);
			if(color.rgbtRed)
			{
				a=255-color.rgbtRed;

				x=posx/Textures[TexPos]->width;
				y=posy/Textures[TexPos]->height;
				x2=posx-(x*Textures[TexPos]->width);
				y2=posy-(y*Textures[TexPos]->height);
				
				pointer=(BYTE*)&Landscape[posx][posy];
				oblue=*pointer;ogreen=*(++pointer);ored=*(++pointer);

				color=Textures[TexPos]->GetPixel(x2,y2);
				red=color.rgbtRed;green=color.rgbtGreen;blue=color.rgbtBlue;

				red=GetAlpha(red,ored,a);
				blue=GetAlpha(blue,oblue,a);
				green=GetAlpha(green,ogreen,a);;
				
				pointer=(BYTE*)&Landscape[posx][posy];
				*pointer=blue;
				*(++pointer)=green;
				*(++pointer)=red;

				height=*(++pointer);
				for(int i3=0;i3<=height;i3++)
					PutVoxel(posx,posy-i3,posx2,posy2-i3);
			}
		}
		Graphics.UnLock();
	}
}

//////////////////////////////////////////////////////////////////////////////////

inline void CLandScape::Smoth()
{
	BYTE cache[128][128];
	BYTE *pointer;
	RGBTRIPLE color;

	ZeroMemory(&cache,sizeof(cache));

	if(GameMain.Status==0)
	{
		for(int i=0;i<32;i++)
			for(int i2=0;i2<32;i2++)
		{
			int posx=ScreenPosX+GameMain.MouseX-100+i-16;
			int posy=ScreenPosY+GameMain.MouseY+i2-16;
			int posx2=GameMain.MouseX+i-16;
			int posy2=GameMain.MouseY+i2-16;

			if(posx2<101 || posx2>559) 
			{
				cache[i][i2]=255;
				continue;
			}
			if(posy2<0 || posy2>479) 
			{
				cache[i][i2]=255;
				continue;
			}

			pointer=(BYTE*)&Landscape[posx][posy];
			pointer+=3;
			
			cache[i][i2]=*pointer;
		}

		for(i=0;i<32;i++)
			for(int i2=0;i2<32;i2++)
		{			
			int posx=ScreenPosX+GameMain.MouseX-100+i-16;
			int posy=ScreenPosY+GameMain.MouseY+i2-16;
			int posx2=GameMain.MouseX+i-16;
			int posy2=GameMain.MouseY+i2-16;
			
			if(posx2<101 || posx2>559) continue;
			if(posy2<0 || posy2>479) continue;
			
			color=Masks[2]->GetPixel(i,i2);
			if(color.rgbtRed)
			{
				int z=0;
				int z2=0;

				for(int i3=-1;i3<2;i3++)
					for(int i4=-1;i4<2;i4++)
					{
						if(i+i3<0) continue;
						if(i2+i4<0) continue;
						
						if(cache[i+i3][i2+i4]==255) continue;

						z2++;
						z+=cache[i+i3][i2+i4];
					}
				z=z/z2;
				
				pointer=(BYTE*)&Landscape[posx][posy];
				pointer+=3;

				*pointer=z;
			}
		}

		Graphics.Lock();
		for(i=0;i<32;i++)
			for(int i2=0;i2<32;i2++)
		{
			int posx=ScreenPosX+GameMain.MouseX-100+i-16;
			int posy=ScreenPosY+GameMain.MouseY+i2-16;
			int posx2=GameMain.MouseX+i-16;
			int posy2=GameMain.MouseY+i2-16;
			
			if(posx2<101 || posx2>559) continue;
			if(posy2<0 || posy2>479) continue;

			pointer=(BYTE*)&Landscape[posx][posy];
			pointer+=3;

			for(int i3=0;i3<=*pointer;i3++)
				PutVoxel(posx,posy-i3,posx2,posy2-i3);
		}
		Graphics.UnLock();
	}

	///////////////////////////////////////////////////////////

	if(GameMain.Status==1)
	{
		for(int i=0;i<64;i++)
			for(int i2=0;i2<64;i2++)
		{
			int posx=ScreenPosX+GameMain.MouseX-100+i-32;
			int posy=ScreenPosY+GameMain.MouseY+i2-32;
			int posx2=GameMain.MouseX+i-32;
			int posy2=GameMain.MouseY+i2-32;
			
			if(posx2<101 || posx2>559) 
			{
				cache[i][i2]=255;
				continue;
			}
			if(posy2<0 || posy2>479) 
			{
				cache[i][i2]=255;
				continue;
			}
			
			pointer=(BYTE*)&Landscape[posx][posy];
			pointer+=3;

			cache[i][i2]=*pointer;
		}

		for(i=0;i<64;i++)
			for(int i2=0;i2<64;i2++)
		{			
			int posx=ScreenPosX+GameMain.MouseX-100+i-32;
			int posy=ScreenPosY+GameMain.MouseY+i2-32;
			int posx2=GameMain.MouseX+i-32;
			int posy2=GameMain.MouseY+i2-32;
			
			if(posx2<101 || posx2>559) continue;
			if(posy2<0 || posy2>479) continue;
			
			color=Masks[1]->GetPixel(i,i2);
			if(color.rgbtRed)
			{
				int z=0;
				int z2=0;

				for(int i3=-1;i3<2;i3++)
					for(int i4=-1;i4<2;i4++)
					{
						if(i+i3<0) continue;
						if(i2+i4<0) continue;
						
						if(cache[i+i3][i2+i4]==255) continue;

						z2++;
						z+=cache[i+i3][i2+i4];
					}
				z=z/z2;
				
				pointer=(BYTE*)&Landscape[posx][posy];
				pointer+=3;

				*pointer=z;
			}
		}

		Graphics.Lock();
		for(i=0;i<64;i++)
			for(int i2=0;i2<64;i2++)
		{
			int posx=ScreenPosX+GameMain.MouseX-100+i-32;
			int posy=ScreenPosY+GameMain.MouseY+i2-32;
			int posx2=GameMain.MouseX+i-32;
			int posy2=GameMain.MouseY+i2-32;
			
			if(posx2<101 || posx2>559) continue;
			if(posy2<0 || posy2>479) continue;

			pointer=(BYTE*)&Landscape[posx][posy];
			pointer+=3;

			for(int i3=0;i3<=*pointer;i3++)
				PutVoxel(posx,posy-i3,posx2,posy2-i3);
		}
		Graphics.UnLock();
	}

	///////////////////////////////////////////////////////////
	
	if(GameMain.Status==2)
	{
		for(int i=0;i<96;i++)
			for(int i2=0;i2<96;i2++)
		{
			int posx=ScreenPosX+GameMain.MouseX-100+i-48;
			int posy=ScreenPosY+GameMain.MouseY+i2-48;
			int posx2=GameMain.MouseX+i-48;
			int posy2=GameMain.MouseY+i2-48;
			
			if(posx2<101 || posx2>559) 
			{
				cache[i][i2]=255;
				continue;
			}
			if(posy2<0 || posy2>479) 
			{
				cache[i][i2]=255;
				continue;
			}
			
			pointer=(BYTE*)&Landscape[posx][posy];
			pointer+=3;

			cache[i][i2]=*pointer;
		}

		for(i=0;i<96;i++)
			for(int i2=0;i2<96;i2++)
		{			
			int posx=ScreenPosX+GameMain.MouseX-100+i-48;
			int posy=ScreenPosY+GameMain.MouseY+i2-48;
			int posx2=GameMain.MouseX+i-48;
			int posy2=GameMain.MouseY+i2-48;
			
			if(posx2<101 || posx2>559) continue;
			if(posy2<0 || posy2>479) continue;
			
			color=Masks[0]->GetPixel(i,i2);
			if(color.rgbtRed)
			{
				int z=0;
				int z2=0;

				for(int i3=-1;i3<2;i3++)
					for(int i4=-1;i4<2;i4++)
					{
						if(i+i3<0) continue;
						if(i2+i4<0) continue;
						
						if(cache[i+i3][i2+i4]==255) continue;

						z2++;
						z+=cache[i+i3][i2+i4];
					}
				z=z/z2;
				
				pointer=(BYTE*)&Landscape[posx][posy];
				pointer+=3;

				*pointer=z;
			}
		}

		Graphics.Lock();
		for(i=0;i<96;i++)
			for(int i2=0;i2<96;i2++)
		{
			int posx=ScreenPosX+GameMain.MouseX-100+i-48;
			int posy=ScreenPosY+GameMain.MouseY+i2-48;
			int posx2=GameMain.MouseX+i-48;
			int posy2=GameMain.MouseY+i2-48;
			
			if(posx2<101 || posx2>559) continue;
			if(posy2<0 || posy2>479) continue;

			pointer=(BYTE*)&Landscape[posx][posy];
			pointer+=3;

			for(int i3=0;i3<=*pointer;i3++)
				PutVoxel(posx,posy-i3,posx2,posy2-i3);
		}
		Graphics.UnLock();
	}
}

//////////////////////////////////////////////////////////////////////////////////

inline void CLandScape::Level()
{
	BYTE *pointer;
	RGBTRIPLE color;

	if(GameMain.Status==0)
	{
		for(int i=0;i<32;i++)
			for(int i2=0;i2<32;i2++)
		{			
			int posx=ScreenPosX+GameMain.MouseX-100+i-16;
			int posy=ScreenPosY+GameMain.MouseY+i2-16;
			int posx2=GameMain.MouseX+i-16;
			int posy2=GameMain.MouseY+i2-16;
			
			if(posx2<101 || posx2>559) continue;
			if(posy2<0 || posy2>479) continue;
			
			color=Masks[2]->GetPixel(i,i2);
			if(color.rgbtRed)
			{
				pointer=(BYTE*)&Landscape[posx][posy];
				pointer+=3;

				if(*pointer==32) continue;
				if(*pointer<32) ++*pointer;
				if(*pointer>32) --*pointer;
			}
		}
	}

	///////////////////////////////////////////////////////////

	if(GameMain.Status==1)
	{
		for(int i=0;i<64;i++)
			for(int i2=0;i2<64;i2++)
		{
			int posx=ScreenPosX+GameMain.MouseX-100+i-32;
			int posy=ScreenPosY+GameMain.MouseY+i2-32;
			int posx2=GameMain.MouseX+i-32;
			int posy2=GameMain.MouseY+i2-32;
				
			if(posx2<101 || posx2>559) continue;
			if(posy2<0 || posy2>479) continue;
			
			color=Masks[1]->GetPixel(i,i2);
			if(color.rgbtRed)
			{
				pointer=(BYTE*)&Landscape[posx][posy];
				pointer+=3;

				if(*pointer==32) continue;
				if(*pointer<32) ++*pointer;
				if(*pointer>32) --*pointer;
			}
		}
	}

	///////////////////////////////////////////////////////////

	if(GameMain.Status==2)
	{
		for(int i=0;i<96;i++)
			for(int i2=0;i2<96;i2++)
		{
			int posx=ScreenPosX+GameMain.MouseX-100+i-48;
			int posy=ScreenPosY+GameMain.MouseY+i2-48;
			int posx2=GameMain.MouseX+i-48;
			int posy2=GameMain.MouseY+i2-48;
			
			if(posx2<101 || posx2>559) continue;
			if(posy2<0 || posy2>479) continue;
	
			color=Masks[0]->GetPixel(i,i2);
			if(color.rgbtRed)
			{
				pointer=(BYTE*)&Landscape[posx][posy];
				pointer+=3;

				if(*pointer==32) continue;
				if(*pointer<32) ++*pointer;
				if(*pointer>32) --*pointer;
			}
		}
	}
}

//////////////////////////////////////////////////////////////////////////////////

inline void CLandScape::Spray()
{
	BYTE *pointer;
	RGBTRIPLE color;
	srand((unsigned)time(NULL));
	int r=0;

	if(GameMain.Status==0)
	{
		for(int i=0;i<32;i++)
			for(int i2=0;i2<32;i2++)
		{			
			int posx=ScreenPosX+GameMain.MouseX-100+i-16;
			int posy=ScreenPosY+GameMain.MouseY+i2-16;
			int posx2=GameMain.MouseX+i-16;
			int posy2=GameMain.MouseY+i2-16;
			
			if(posx2<101 || posx2>559) continue;
			if(posy2<0 || posy2>479) continue;
			
			color=Masks[2]->GetPixel(i,i2);
			if(color.rgbtRed)
			{
				pointer=(BYTE*)&Landscape[posx][posy];
				pointer+=3;
				
				r=rand()%4;
	
				if(r==1 && *pointer<64) ++*pointer;
				if(r==2 && *pointer<64) ++*pointer;
			}
		}
	}

	///////////////////////////////////////////////////////////

	if(GameMain.Status==1)
	{
		for(int i=0;i<64;i++)
			for(int i2=0;i2<64;i2++)
		{
			int posx=ScreenPosX+GameMain.MouseX-100+i-32;
			int posy=ScreenPosY+GameMain.MouseY+i2-32;
			int posx2=GameMain.MouseX+i-32;
			int posy2=GameMain.MouseY+i2-32;
				
			if(posx2<101 || posx2>559) continue;
			if(posy2<0 || posy2>479) continue;
			
			color=Masks[1]->GetPixel(i,i2);
			if(color.rgbtRed)
			{
				pointer=(BYTE*)&Landscape[posx][posy];
				pointer+=3;

				r=rand()%4;
	
				if(r==1 && *pointer<64) ++*pointer;
				if(r==2 && *pointer<64) ++*pointer;
			}
		}
	}

	///////////////////////////////////////////////////////////

	if(GameMain.Status==2)
	{
		for(int i=0;i<96;i++)
			for(int i2=0;i2<96;i2++)
		{
			int posx=ScreenPosX+GameMain.MouseX-100+i-48;
			int posy=ScreenPosY+GameMain.MouseY+i2-48;
			int posx2=GameMain.MouseX+i-48;
			int posy2=GameMain.MouseY+i2-48;
			
			if(posx2<101 || posx2>559) continue;
			if(posy2<0 || posy2>479) continue;
	
			color=Masks[0]->GetPixel(i,i2);
			if(color.rgbtRed)
			{
				pointer=(BYTE*)&Landscape[posx][posy];
				pointer+=3;

				r=rand()%4;
	
				if(r==1 && *pointer<64) ++*pointer;
				if(r==2 && *pointer<64) ++*pointer;
			}
		}
	}

}

//////////////////////////////////////////////////////////////////////////////////

inline void CLandScape::Transparent()
{
	if(Menu.Selection==-1) return;

	DWORD buffer2;
	int TexPos=Menu.ScrolPos+Menu.Selection;
	int x,y,x2,y2;
	int a,b;
	RGBTRIPLE color;
	float red,green,blue;
	float ored,ogreen,oblue;
	BYTE *pointer;
	BYTE height;

	if(GameMain.Status==0)
	{
		Graphics.Lock();
		for(int i=0;i<32;i++)
			for(int i2=0;i2<32;i2++)
		{			
			int posx=ScreenPosX+GameMain.MouseX-100+i-16;
			int posy=ScreenPosY+GameMain.MouseY+i2-16;
			int posx2=GameMain.MouseX+i-16;
			int posy2=GameMain.MouseY+i2-16;
			
			if(posx2<101 || posx2>559) continue;
			if(posy2<0 || posy2>479) continue;
			
			color=Masks[2]->GetPixel(i,i2);
			if(color.rgbtRed)
			{
				a=255-color.rgbtRed;

				x=posx/Textures[TexPos]->width;
				y=posy/Textures[TexPos]->height;
				x2=posx-(x*Textures[TexPos]->width);
				y2=posy-(y*Textures[TexPos]->height);
				
				pointer=(BYTE*)&Landscape[posx][posy];
				oblue=*pointer;ogreen=*(++pointer);ored=*(++pointer);

				color=Textures[TexPos]->GetPixel(x2,y2);
				red=color.rgbtRed;green=color.rgbtGreen;blue=color.rgbtBlue;

				if(a<192) a=192;
				red=GetAlpha(red,ored,a);
				blue=GetAlpha(blue,oblue,a);
				green=GetAlpha(green,ogreen,a);
				
				pointer=(BYTE*)&Landscape[posx][posy];
				*pointer=blue;
				*(++pointer)=green;
				*(++pointer)=red;

				height=*(++pointer);
				for(int i3=0;i3<=height;i3++)
					PutVoxel(posx,posy-i3,posx2,posy2-i3);
			}
		}
		Graphics.UnLock();

	}

	///////////////////////////////////////////////////////////

	if(GameMain.Status==1)
	{
		Graphics.Lock();
		for(int i=0;i<64;i++)
			for(int i2=0;i2<64;i2++)
		{
			int posx=ScreenPosX+GameMain.MouseX-100+i-32;
			int posy=ScreenPosY+GameMain.MouseY+i2-32;
			int posx2=GameMain.MouseX+i-32;
			int posy2=GameMain.MouseY+i2-32;
				
			if(posx2<101 || posx2>559) continue;
			if(posy2<0 || posy2>479) continue;
			
			color=Masks[1]->GetPixel(i,i2);
			if(color.rgbtRed)
			{
				a=255-color.rgbtRed;

				x=posx/Textures[TexPos]->width;
				y=posy/Textures[TexPos]->height;
				x2=posx-(x*Textures[TexPos]->width);
				y2=posy-(y*Textures[TexPos]->height);
				
				pointer=(BYTE*)&Landscape[posx][posy];
				oblue=*pointer;ogreen=*(++pointer);ored=*(++pointer);

				color=Textures[TexPos]->GetPixel(x2,y2);
				red=color.rgbtRed;green=color.rgbtGreen;blue=color.rgbtBlue;

				if(a<192) a=192;
				red=GetAlpha(red,ored,a);
				blue=GetAlpha(blue,oblue,a);
				green=GetAlpha(green,ogreen,a);
				
				pointer=(BYTE*)&Landscape[posx][posy];
				*pointer=blue;
				*(++pointer)=green;
				*(++pointer)=red;

				height=*(++pointer);
				for(int i3=0;i3<=height;i3++)
					PutVoxel(posx,posy-i3,posx2,posy2-i3);
			}
		}
		Graphics.UnLock();
	}

	///////////////////////////////////////////////////////////

	if(GameMain.Status==2)
	{
		Graphics.Lock();
		for(int i=0;i<96;i++)
			for(int i2=0;i2<96;i2++)
		{
			int posx=ScreenPosX+GameMain.MouseX-100+i-48;
			int posy=ScreenPosY+GameMain.MouseY+i2-48;
			int posx2=GameMain.MouseX+i-48;
			int posy2=GameMain.MouseY+i2-48;
			
			if(posx2<101 || posx2>559) continue;
			if(posy2<0 || posy2>479) continue;
	
			color=Masks[0]->GetPixel(i,i2);
			if(color.rgbtRed)
			{
				a=255-color.rgbtRed;

				x=posx/Textures[TexPos]->width;
				y=posy/Textures[TexPos]->height;
				x2=posx-(x*Textures[TexPos]->width);
				y2=posy-(y*Textures[TexPos]->height);
				
				pointer=(BYTE*)&Landscape[posx][posy];
				oblue=*pointer;ogreen=*(++pointer);ored=*(++pointer);

				color=Textures[TexPos]->GetPixel(x2,y2);
				red=color.rgbtRed;green=color.rgbtGreen;blue=color.rgbtBlue;

				if(a<192) a=192;
				red=GetAlpha(red,ored,a);
				blue=GetAlpha(blue,oblue,a);
				green=GetAlpha(green,ogreen,a);;
				
				pointer=(BYTE*)&Landscape[posx][posy];
				*pointer=blue;
				*(++pointer)=green;
				*(++pointer)=red;

				height=*(++pointer);
				for(int i3=0;i3<=height;i3++)
					PutVoxel(posx,posy-i3,posx2,posy2-i3);
			}
		}
		Graphics.UnLock();
	}
}

//////////////////////////////////////////////////////////////////////////////////

inline BYTE CLandScape::GetAlpha(BYTE a,BYTE b,float alpha)
{
	float diff=a-b;	

	if(diff<0) 
	{
		//diff=diff*(-1);
		diff=diff*(alpha/-255);
		return(a+diff);
	}
	else
	{
		diff=diff*(alpha/255);
		return(a-diff);
	}
}

//////////////////////////////////////////////////////////////////////////////////
//							Move operations										//
//////////////////////////////////////////////////////////////////////////////////

HICON CLandScape::CheckMouseCursor()
{
	if(CheckBoxes[0]->State) return(GameMain.Cursor);

	if(GameMain.KeyboardB[0]==129 && GameMain.KeyboardB[1]==132)
	{
		MoveLeftDown();
		return(GameMain.Cursor);
	}

	if(GameMain.KeyboardB[0]==129 && GameMain.KeyboardB[1]==131)
	{
		MoveLeftUp();
		return(GameMain.Cursor);
	}

	if(GameMain.KeyboardB[0]==130 && GameMain.KeyboardB[1]==132)
	{
		MoveRightDown();
		return(GameMain.Cursor);
	}

	if(GameMain.KeyboardB[0]==130 && GameMain.KeyboardB[1]==131)
	{
		MoveRightUp();
		return(GameMain.Cursor);
	}

	if(GameMain.KeyboardB[0]==132)
	{
		MoveDown();
		return(GameMain.Cursor);
	}

	if(GameMain.KeyboardB[0]==131)
	{
		MoveUp();
		return(GameMain.Cursor);
	}

	if(GameMain.KeyboardB[0]==130)
	{
		MoveRight();
		return(GameMain.Cursor);
	}

	if(GameMain.KeyboardB[0]==129)
	{
		MoveLeft();
		return(GameMain.Cursor);
	}	

	if(GameMain.MouseX>=636 && GameMain.MouseY>=476)
	{
		MoveRightDown();
		GameMain.CursorRegX=-16;
		GameMain.CursorRegY=-14;
		return(GameMain.RightDown);
	}
	if(GameMain.MouseX>=636 && GameMain.MouseY<=3)
	{
		MoveRightUp();
		GameMain.CursorRegX=-14;
		GameMain.CursorRegY=0;
		return(GameMain.RightUp);
	}
	if(GameMain.MouseX<=3 && GameMain.MouseY<=3)
	{
		MoveLeftUp();
		GameMain.CursorRegX=0;
		GameMain.CursorRegY=0;
		return(GameMain.LeftUp);
	}
	if(GameMain.MouseX<=3 && GameMain.MouseY>=476)
	{
		MoveLeftDown();
		GameMain.CursorRegX=0;
		GameMain.CursorRegY=-15;
		return(GameMain.LeftDown);
	}
	if(GameMain.MouseX>=636)
	{
		MoveRight();
		GameMain.CursorRegX=-19;
		GameMain.CursorRegY=0;
		return(GameMain.Right);
	}
	if(GameMain.MouseX<=3)
	{
		MoveLeft();
		GameMain.CursorRegX=0;
		GameMain.CursorRegY=0;
		return(GameMain.Left);
	}
	if(GameMain.MouseY<=3)
	{
		MoveUp();
		GameMain.CursorRegX=0;
		GameMain.CursorRegY=0;
		return(GameMain.Up);
	}
	if(GameMain.MouseY>=476)
	{
		MoveDown();
		GameMain.CursorRegX=0;
		GameMain.CursorRegY=-19;
		return(GameMain.Down);
	}
	
	GameMain.CursorRegX=0;
	GameMain.CursorRegY=0;
	return(GameMain.Cursor);
}

//////////////////////////////////////////////////////////////////////////////////

inline void CLandScape::MoveRight()
{
	if(ScreenPosX>1530) return;

	ScreenPosX+=10;
	Graphics.Blt(111,0,559,480,-10,0);
	Graphics.Lock();
	FillScreen(549,0,559,479);	
	Graphics.UnLock();
}

//////////////////////////////////////////////////////////////////////////////////

inline void CLandScape::MoveLeft()
{
	if(ScreenPosX==0) return;
	ScreenPosX-=10;
	Graphics.Blt(100,0,550,480,10,0);
	Graphics.Lock();
	FillScreen(101,0,111,479);
	Graphics.UnLock();
}

//////////////////////////////////////////////////////////////////////////////////

inline void CLandScape::MoveUp()
{
	if(ScreenPosY==0) return;
	ScreenPosY-=10;
	Graphics.Blt(101,0,560,470,0,10);
	Graphics.Lock();
	FillScreen(101,0,559,10);
	Graphics.UnLock();
}

//////////////////////////////////////////////////////////////////////////////////

inline void CLandScape::MoveDown()
{
	if(ScreenPosY==1450) return;
	ScreenPosY+=10;
	Graphics.Blt(101,10,560,480,0,-10);
	Graphics.Lock();
	FillScreen(101,469,559,479);
	Graphics.UnLock();
}

//////////////////////////////////////////////////////////////////////////////////

inline void CLandScape::MoveRightUp()
{
	if(ScreenPosX>=1540)
	{
		MoveUp(); return;
	}
	if(ScreenPosY==0)
	{
		MoveRight(); return;
	}
	ScreenPosY-=10;
	ScreenPosX+=10;
	Graphics.Blt(111,0,560,470,-10,10);
	Graphics.Lock();
	FillScreen(549,0,559,479);	
	FillScreen(101,0,548,10);
	Graphics.UnLock();
}

//////////////////////////////////////////////////////////////////////////////////

inline void CLandScape::MoveRightDown()
{
	if(ScreenPosX>=1540)
	{
		MoveDown(); return;
	}
	if(ScreenPosY==1450)
	{
		MoveRight(); return;
	}
	ScreenPosY+=10;
	ScreenPosX+=10;
	Graphics.Blt(111,10,559,480,-10,-10);
	Graphics.Lock();
	FillScreen(549,0,559,470);
	FillScreen(101,470,559,479);
	Graphics.UnLock();
}

//////////////////////////////////////////////////////////////////////////////////

inline void CLandScape::MoveLeftUp()
{
	if(ScreenPosX==0)
	{
		MoveUp(); return;
	}
	if(ScreenPosY==0)
	{
		MoveLeft(); return;
	}
	ScreenPosX-=10;
	ScreenPosY-=10;
	Graphics.Blt(101,0,549,470,10,10);
	Graphics.Lock();
	FillScreen(101,0,559,10);
	FillScreen(101,10,110,479);
	Graphics.UnLock();
}

//////////////////////////////////////////////////////////////////////////////////

inline void CLandScape::MoveLeftDown()
{
	if(ScreenPosX==0)
	{
		MoveDown(); return;
	}
	if(ScreenPosY==1450)
	{
		MoveLeft(); return;
	}
	ScreenPosX-=10;
	ScreenPosY+=10;
	Graphics.Blt(101,10,549,480,10,-10),
	Graphics.Lock();
	FillScreen(101,469,559,479);
	FillScreen(101,10,111,479);
	Graphics.UnLock();
}
