// CLiquid.cpp
// by Comanche

#include "CMain.h"
#include "CGraphics.h"
#include "CLog.h"
#include "CLiquid.h"
#include "CLandScape.h"
#include "CTexture.h"

extern CMain GameMain;
extern CGraphics Graphics;
extern CLog Log;
extern CLandScape Land;
extern CTexture *Textures[1024];

//////////////////////////////////////////////////////////////////////////////////

CLiquid::CLiquid(int Texture)
{
	int i=0;
	int TempX,TempY,TempX2,TempY2;
	height=0;

	strcpy(TextureName,Textures[Texture]->Name);
	TexId = Texture;

	while(i<2)
	{
		GameMain.GetMouseInfo();
		if(GameMain.MouseX<101) GameMain.MouseX=101;
		if(GameMain.MouseX>559) GameMain.MouseX=559;		
		Graphics.BltToBackBuffer();

		Graphics.LockBackBuffer();
		if(GameMain.CheckMouseRange(101,0,559,479,FALSE) && i==0)
		{
			if(GameMain.MouseB[0])
			{
				TempX=GameMain.MouseX;
				TempY=GameMain.MouseY;
				i++;
			}
		}
		if(GameMain.CheckMouseRange(101,0,559,479,FALSE) && i==1)
		{	
			if(GameMain.MouseX>TempX && GameMain.MouseY>TempY)
			{
				Graphics.Quader(TempX,TempY,GameMain.MouseX,GameMain.MouseY,0,0,150);
				if(GameMain.MouseB[0])
				{
					TempX2=GameMain.MouseX;
					TempY2=GameMain.MouseY;
					i++;
				}
			}
		}
		Graphics.UnLockBackBuffer();

		GameMain.RenderLiquids();

		x=TempX+Land.ScreenPosX-100;
		y=TempY+Land.ScreenPosY;
		x2=TempX2+Land.ScreenPosX-100;
		y2=TempY2+Land.ScreenPosY;		
		
		Graphics.GetDC();
		DrawIcon(Graphics.xdc,GameMain.MouseX-7,GameMain.MouseY-7,GameMain.Cross);
		Graphics.ReleaseDC();
		Graphics.Flip();
	}

	while(GameMain.MouseB[0])
		GameMain.GetMouseInfo();
}

//////////////////////////////////////////////////////////////////////////////////

CLiquid::~CLiquid()
{
}

//////////////////////////////////////////////////////////////////////////////////

void CLiquid::Render()
{	
}

//////////////////////////////////////////////////////////////////////////////////

void CLiquid::RenderOutline(BOOL Marked)
{
	int TempX,TempY,TempX2,TempY2;

	Graphics.LockBackBuffer();
	
	TempX=x-Land.ScreenPosX+100;
	TempY=y-Land.ScreenPosY-height;
	TempX2=x2-Land.ScreenPosX+100;
	TempY2=y2-Land.ScreenPosY-height;
	
	if(Marked)
	{
		for (int i=TempX;i<=TempX2;i++)
		{		
			Graphics.PutSafePixel(i,TempY,0,0,220);
			Graphics.PutSafePixel(i,TempY2,0,0,220);
		}
		for (int i2=TempY;i2<=TempY2;i2++)
		{
			Graphics.PutSafePixel(TempX,i2,0,0,220);
			Graphics.PutSafePixel(TempX2,i2,0,0,220);
		}
	}
	else
	{
		for (int i=TempX;i<=TempX2;i++)
		{		
			Graphics.PutSafePixel(i,TempY,0,0,150);
			Graphics.PutSafePixel(i,TempY2,0,0,150);
		}
		for (int i2=TempY;i2<=TempY2;i2++)
		{
			Graphics.PutSafePixel(TempX,i2,0,0,150);
			Graphics.PutSafePixel(TempX2,i2,0,0,150);
		}
	}
	int Temp=TempY+((TempY2-TempY)/2)-1;
	int Temp2=TempX+((TempX2-TempX)/2)-1;
	for(int i=0;i<4;i++)
	{
		for(int i2=0;i2<4;i2++)
		{
			Graphics.PutSafePixel(i+TempX-2,i2+Temp,0,0,255);
			Graphics.PutSafePixel(i+TempX2-1,i2+Temp,0,0,255);
			Graphics.PutSafePixel(i+Temp2,i2+TempY-2,0,0,255);
			Graphics.PutSafePixel(i+Temp2,i2+TempY2-1,0,0,255);
		}
	}

	Graphics.UnLockBackBuffer();
}

//////////////////////////////////////////////////////////////////////////////////

void CLiquid::CheckMouse(int Liquid)
{
	int TempX = x-Land.ScreenPosX+100;
	int TempY = y-Land.ScreenPosY;
	int TempX2 = x2-Land.ScreenPosX+100;
	int TempY2 = y2-Land.ScreenPosY;
	int TempX3 = (x2-x)/2;
	int TempY3 = (y2-y)/2;

	if(GameMain.CheckMouseRange(TempX-4,TempY-height,TempX+4,TempY2-height,FALSE))
	{
		GameMain.ActiveLiquid=Liquid;
	}
	if(GameMain.CheckMouseRange(TempX2-4,TempY-height,TempX2+4,TempY2-height,FALSE))
	{
		GameMain.ActiveLiquid=Liquid;
	}
	if(GameMain.CheckMouseRange(TempX,TempY-4-height,TempX2,TempY+4-height,FALSE))	
	{
		GameMain.ActiveLiquid=Liquid;
	}
	if(GameMain.CheckMouseRange(TempX,TempY2-4,TempX2,TempY2+4-height,FALSE))	
	{
		GameMain.ActiveLiquid=Liquid;
	}

	if(GameMain.CheckMouseRange(TempX-4,TempY+TempY3-4-height,
								TempX+4,TempY+TempY3+4-height,FALSE))
	{
		GameMain.Icon=GameMain.LeftRight;
		if(GameMain.MouseB[0])
		{
			while(GameMain.MouseB[0])
			{
				GameMain.GetMouseInfo();
				if(GameMain.MouseX>=TempX2) GameMain.MouseX=TempX2-1;
				if(GameMain.MouseX>559) GameMain.MouseX=559;
				if(GameMain.MouseX<101) GameMain.MouseX=101;
				x=GameMain.MouseX+Land.ScreenPosX-100;
				Graphics.BltToBackBuffer();
				GameMain.RenderLiquids();
				Graphics.GetDC();
				DrawIcon(Graphics.xdc,GameMain.MouseX-7,GameMain.MouseY-7,GameMain.LeftRight);
				Graphics.ReleaseDC();
				Graphics.Flip();
			}
		}
		while(GameMain.MouseB[0])
			GameMain.GetMouseInfo();
		return;
	}
	if(GameMain.CheckMouseRange(TempX2-4,TempY+TempY3-4-height,
								TempX2+4,TempY+TempY3+4-height,FALSE))
	{
		GameMain.Icon=GameMain.LeftRight;
		if(GameMain.MouseB[0])
		{
			while(GameMain.MouseB[0])
			{
				GameMain.GetMouseInfo();
				if(GameMain.MouseX<=TempX) GameMain.MouseX=TempX+1;
				if(GameMain.MouseX>559) GameMain.MouseX=559;
				if(GameMain.MouseX<101) GameMain.MouseX=101;
				x2=GameMain.MouseX+Land.ScreenPosX-100;
				Graphics.BltToBackBuffer();
				GameMain.RenderLiquids();
				Graphics.GetDC();
				DrawIcon(Graphics.xdc,GameMain.MouseX-7,GameMain.MouseY-7,GameMain.LeftRight);
				Graphics.ReleaseDC();
				Graphics.Flip();
			}
		}
		while(GameMain.MouseB[0])
			GameMain.GetMouseInfo();
		return;
	}
	if(GameMain.CheckMouseRange(TempX+TempX3-4,TempY-4-height,
								TempX+TempX3+4,TempY+4-height,FALSE))
	{
		GameMain.Icon=GameMain.UpDown;
		if(GameMain.MouseB[0])
		{
			while(GameMain.MouseB[0])
			{
				GameMain.GetMouseInfo();
				if(GameMain.MouseY>=TempY2) GameMain.MouseY=TempY2-1;
				y=GameMain.MouseY+Land.ScreenPosY;
				Graphics.BltToBackBuffer();
				GameMain.RenderLiquids();
				Graphics.GetDC();
				DrawIcon(Graphics.xdc,GameMain.MouseX-7,GameMain.MouseY-7,GameMain.UpDown);
				Graphics.ReleaseDC();
				Graphics.Flip();
			}
		}
		while(GameMain.MouseB[0])
			GameMain.GetMouseInfo();
		return;
	}
	if(GameMain.CheckMouseRange(TempX+TempX3-4,TempY2-4-height,
								TempX+TempX3+4,TempY2+4-height,FALSE))
	{
		GameMain.Icon=GameMain.UpDown;
		if(GameMain.MouseB[0])
		{
			while(GameMain.MouseB[0])
			{
				GameMain.GetMouseInfo();
				if(GameMain.MouseY<=TempY) GameMain.MouseY=TempY+1;
				y2=GameMain.MouseY+Land.ScreenPosY;
				Graphics.BltToBackBuffer();
				GameMain.RenderLiquids();
				Graphics.GetDC();
				DrawIcon(Graphics.xdc,GameMain.MouseX-7,GameMain.MouseY-7,GameMain.UpDown);
				Graphics.ReleaseDC();
				Graphics.Flip();
			}
		}
		while(GameMain.MouseB[0])
			GameMain.GetMouseInfo();
		return;
	}
}
