// CMain.h
// by Comanche

#include "defines.h"

#ifndef CMAIN
#define CMAIN

//////////////////////////////////////////////////////////////////////////////////

class CMain
{
public:
	BOOL GameInit(HWND main_window_handle);
	BOOL CheckProzessor();
	BOOL CheckDirectX();
	BOOL GameMain();
	BOOL GameStart();
	BOOL GameShutdown();
	BOOL GameRestart();	
	BOOL MouseInit(HWND hwnd);
	BOOL KeyboardInit(HWND hwnd);
	BOOL GetMouseInfo();
	BOOL GetKeyboardInfo();
	BOOL CheckMouseRange(int x,int y,int x2,int y2,BOOL Button);
	BOOL LoadTextures();
	BOOL RenderLiquids();
	BOOL CheckLiquids();

	LPDIRECTDRAW         lpdd;					// dd object
	LPDIRECTDRAW2		 lpdd2;					// dd2 object
	LPDIRECTDRAWSURFACE  lpddsprimary;			// dd primary surface
	LPDIRECTDRAWSURFACE  lpddsback;				// dd back surface
	LPDIRECTDRAWSURFACE	 lpddsos1;				// dd off-screen surface 1
	LPDIRECTINPUT		 lpdi;					// di object
	LPDIRECTINPUTDEVICE  lpdidevice;			// di device
	LPDIRECTINPUTDEVICE  lpdidevice2;			// di device 2
	DIMOUSESTATE		 mouse_state;			// di mouse state
	DDSURFACEDESC        ddsd;					// a direct draw surface description struct
	DDSCAPS              ddscaps;				// a direct draw surface capabilities struct
	HRESULT              ddrval;				// result back from dd calls
	int					 MouseX,MouseY;			// Mouse coordinates
	BYTE				 MouseB[3];				// Mousebutton states
	BYTE				 keyboard_state[256];
	BYTE				 KeyboardB[4];
	HICON				 Icon,Cursor,Cross,Finger,Pinpet,Clock,
						 Right,Left,Up,Down,LeftRight,UpDown,
						 RightDown,RightUp,LeftDown,LeftUp; // Cursors;
	int					 NumTextures, CursorRegX,CursorRegY,Status,Status2;
	BOOL				 DrawCursor;			// Mouse Cursor ON/OFF
	int					 Editor;	
	int					 ActiveLiquid;
	BOOL 				 MMX,CPUID,FPU,CMOV,MCA,TSC,AMD,INTEL;
	int					 CpuFamily,CpuModel,CpuStepId;
	char				 VendorString[32];
	DWORD				 DXVersion, DXPlatform;
private:
	char buffer[80];
};

#endif
